/******************************************************************************
 Quelltext teilweise aus dem Buch "VGA- und SVGA-Karten programmieren"
 aus dem Franzis-Verlag, 1994

 T. Baier
******************************************************************************/

extern void vinit(int window, char font);
extern void clrend(int x, int y);
extern void putpx16_2(int x, int y, char color);
extern void putpx16_0(int x, int y);
extern void putvline(int x, int y, int y_new);
extern void putbyte(int x, int y, char data);
extern void put_char(int x, int y, char data);
extern void set_px(char x);
extern void set_strt(void);
extern far pascal unsigned int x_origin;
extern far pascal unsigned int y_origin;
extern far pascal unsigned int textlines;
extern far pascal unsigned int nlines;
extern far pascal unsigned int bpchar;
extern unsigned _stklen = 55535;
typedef struct {
   int x;
   int y;
   int xo;
   int yo;
   float f;
   float db;
   char typ;
   char rm;
   char text[29];
   } Tmarker;
Tmarker marker[9];

#include <math.h>
#include <stdlib.h>
#include <dos.h>
#include "gfx.h"
#include "gfx.c"
#include "svga.c"
#include "system.c"
#include "init.c"
#include "test.c"

const hiband=0x40;
const loband=0x0;
float ZF=471.828, f_adder=0;
BYTE band, fband;
unsigned int mess[4096], im=0, imm=0;
int dbcal[4096], dbmess[4096], dbmin=-110, dbmax=-10, deltadb=100;
unsigned int GridHeight,GridWidth,GridX,GridY,Ymin,Ymax;
int deltaY;
unsigned int width=800, height=600;
void interrupt (*altvec)(void);
int dbcal_exist, fcal_exist;
float fcal[558], fu, fo, deltaf, fc;
int raster[1024];	    //adc-raster(plot-raster)
int Trace[1024];	    //gespeicherte Kurve
float ref;		    //Torzeit in Sekunden (Ausgabe)
float fact=5./4.999992847;  //Frequenz-Korrekturfaktor
char clock=16;	     //Referenz-Vorteiler-Faktor
unsigned int pre=64;        //Prescaler-Faktor
float accuracy; 	    //Genauigkeit in Hz (Ausgabe)
BYTE modus=0; //0: ADC lesen
	      //1: Timer
	      //2: Counter
	      //3: hold
BYTE segment=0; //aktuell beschriebenes Segment von mess
int timer=0;	//Timer wird per Interrupt dekrementiert
BYTE cevent=0;	//0: 1. mal warten auf Counter 1. Zhlung: fu
		//1: 2. mal warten auf Counter 1. Zhlung: fu
		//2: 1. mal warten auf Counter 2. Zhlung: fo
		//3: 2. mal warten auf Counter 2. Zhlung: fo

int nfcal;
float dfcal;
char kaltstart=1;
char thru=0;
int tcal[1024];
char erase=1;
int mess_postfix=1000;

int sweep_t[10]  ={640,320,160,80,40,50,78};
char sweep_dac[10]={ 1,  1,  1, 1, 1, 2, 8};
char sweep_str[10][6]={"  2 s\x0","  1 s\x0","0,5 s\x0","0,3 s\x0","0,1 s\x0"
		       ,"80 ms\x0","40 ms\x0"};
char sweep_n=6, sweep_i=4;
int inttimer;
int dac_inc;
int dac_value=4096;
int dac_old=1024;
int bottomline;
int nmark=0;
int lx,lpos,rx,rpos,lrdb=-300,maxx;



void main(int argc, char *argv[])
{
int i;
WORD j;
char Line[128], Line2[128];
int key, dummy;
int tseg;

start:
modus=3;
thru=0;
erase=1;
band=loband;
fband=0;
f_adder=0;
start2:
ZF=471.828;
modus=3;

if (argv[1]!=NULL)    //kein Runtimeargument?
     { width  = 1024;
       height =  768; } //sonst 800x600

init_counter();
graph_init();
draw_grid(width-48);
//PutString(width/2-15*8,0,"DG8SAQ Scalar Network Analyzer",1);
init_dac();
dbcal_exist = read_dbcal();   //Hier kann Warnung fr Default-Calfile eingegeben werden
fcal_exist = read_fcal();     //Hier kann Warnung fr Default-Calfile eingegeben werden
if (dbcal_exist) PutString(0,64,"dBcal",5);
if (fcal_exist)  PutString(0,80,"fcal",5);


			      //f=1,19318 MHz / Argument
			      //120 = 9,94kHz
set_timer(inttimer);	      //Timer fr ADC-Messung setzen
if (kaltstart) init_adc();

put_db(dbmax, deltadb);

out_Sequencer(0x2,2);
out_f();
modus=0;

do ; while (segment<2); //3.segment
do
  {  markers();
     plot2(2);
     out_f();
     do
       if (kbhit())
	 #include  "key.inc"
     while (segment<3);
     markers();
     plot3(2);
     out_f();
     do
       if (kbhit())
	 #include  "key.inc"
     while (segment>0);
     markers();
     plot4(2);
     out_f();
     do
       if (kbhit())
	 #include  "key.inc"
     while (segment<1);
     markers();
     plot1(2);
     out_f();
     do
       if (kbhit())
	 #include  "key.inc"
     while (segment<2);}
while (1);   //Endlosschleife
ende:
term_prog();
} //Ende
